%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%% Now on to the modeling of psychophysics %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Bayesian integration with Gaussians
x=-10:0.1:10
muPrior=1;
sigmaPrior=1.5;
prior=exp(-(x-muPrior).^2/(2*sigmaPrior^2));
prior=prior/sum(prior);
plot(x,prior,'g');
muLikelihood=2;
sigmaLikelihood=1;
likelihood=exp(-(x-muLikelihood).^2/(2*sigmaLikelihood^2));
likelihood=likelihood/sum(likelihood);
hold on
plot(x,likelihood,'r');
posterior=prior.*likelihood;
posterior=posterior/(sum(posterior));
plot(x,posterior,'y');
hold off
%% Predict experimental results in psychophysical experiments
predictPsychophysics
%% Causal inference
% this has just a single line of change
feedbacks=-8:.2:8
for i=1:length(feedbacks)
    plot(x,prior,'g');
    muLikelihood=feedbacks(i);
    sigmaLikelihood=1;
    likelihood=exp(-(x-muLikelihood).^2/(2*sigmaLikelihood^2));
    likelihood=likelihood+0.05;
    likelihood=likelihood/sum(likelihood);
    hold on
    plot(x,likelihood,'r');
    posterior=prior.*likelihood;
    posterior=posterior/(sum(posterior));
    meanPosterior(i)=sum(posterior.*x);
    plot(x,posterior,'y');
    hold off
    pause(0.2);
end
plot(feedbacks,meanPosterior)
